theory Test_Z_Transform imports Isac begin

section {*trials towards Z transform *}
subsection {*terms*}
ML {*
@{term "1 < || z ||"};
@{term "z / (z - 1)"};
@{term "-u -n - 1"};
@{term "-u [-n - 1]"}; (*[ ] denotes lists !!!*)
@{term "z /(z - 1) = -u [-n - 1]"};
@{term "1 < || z || ==> z / (z - 1) = -u [-n - 1]"};
term2str @{term "1 < || z || ==> z / (z - 1) = -u [-n - 1]"};
*}
ML {*
(*alpha -->  "</alpha>" *)

@{term "\<alpha> "};
@{term "\<delta> "};
@{term "\<phi> "};
@{term "\<rho> "};
term2str @{term "\<rho> "};
*}

subsection {*rules*}
(*axiomatization "z / (z - 1) = -u [-n - 1]" Illegal variable name: "z / (z - 1) = -u [-n - 1]" *)
(*definition     "z / (z - 1) = -u [-n - 1]" Bad head of lhs: existing constant "op /"*)
axiomatization where 
  rule1: "1 = \<delta>[n]" and
  rule2: "|| z || > 1 ==> z / (z - 1) = u [n]" and
  rule3: "|| z || < 1 ==> z / (z - 1) = -u [-n - 1]" and 
  rule4: "|| z || > || \<alpha> || ==> z / (z - \<alpha>) = \<alpha>^n * u [n]" and
  rule5: "|| z || < || \<alpha> || ==> z / (z - \<alpha>) = -(\<alpha>^n) * u [-n - 1]" and
  rule6: "|| z || > 1 ==> z/(z - 1)^2 = n * u [n]"
ML {*
@{thm rule1};
@{thm rule2};
@{thm rule3};
@{thm rule4};
*}

subsection {*apply rules*}
ML {*
val inverse_Z = append_rls "inverse_Z" e_rls
  [ Thm  ("rule3",num_str @{thm rule3}),
    Thm  ("rule4",num_str @{thm rule4}),
    Thm  ("rule1",num_str @{thm rule1})   
  ];

val t = str2term "z / (z - 1) + z / (z - \<alpha>) + 1";
val SOME (t', asm) = rewrite_set_ thy true inverse_Z t;
term2str t' = "z / (z - ?\<delta> [?n]) + z / (z - \<alpha>) + ?\<delta> [?n]"; (*attention rule1 !!!*)
*}
ML {*
val (thy, ro, er) = (@{theory}, tless_true, eval_rls);
*}
ML {*
val SOME (t, asm1) = rewrite_ thy ro er true (num_str @{thm rule3}) t;
term2str t = "- ?u [- ?n - 1] + z / (z - \<alpha>) + 1"; (*- real *)
term2str t;
*}
ML {*
val SOME (t, asm2) = rewrite_ thy ro er true (num_str @{thm rule4}) t;
term2str t = "- ?u [- ?n - 1] + \<alpha> ^ ?n * ?u [?n] + 1"; (*- real *)
term2str t;
*}
ML {*
val SOME (t, asm3) = rewrite_ thy ro er true (num_str @{thm rule1}) t;
term2str t = "- ?u [- ?n - 1] + \<alpha> ^ ?n * ?u [?n] + ?\<delta> [?n]"; (*- real *)
term2str t;
*}
ML {*
terms2str (asm1 @ asm2 @ asm3);
*}

subsection {*prepare expression*}
ML {*
val ctxt = ProofContext.init_global @{theory Isac};
val ctxt = declare_constraints' [@{term "z::real"}] ctxt;
val SOME expression = parseNEW ctxt "3 / (-1/8 + -1/4*z + z^2)";
term2str expression;
*}

subsection {*solve equation*}
ML {*(*from test/Tools/isac/Minisubpbl/100-init-rootpbl.sml*)
"----------- Minisubplb/100-init-rootpbl.sml ---------------------";
val denominator = parseNEW ctxt "z^2 - 1/4*z - 1/8 = 0";
val fmz = ["equality (z^2 - 1/4*z - 1/8 = (0::real))", "solveFor z","solutions L"];
val (dI',pI',mI') =("Isac", ["univariate","equation"], ["no_met"]);
*}
ML {*
val (p,_,f,nxt,_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
(*[
(([], Frm), solve (z ^ 2 - 1 / 4 * z - 1 / 8 = 0, z)),
(([1], Frm), z ^ 2 - 1 / 4 * z - 1 / 8 = 0),              bad rewrite order
(([1], Res), -1 / 8 + z ^ 2 + -1 / 4 * z = 0),            bad pattern
(([2], Pbl), solve (-1 / 8 + z ^ 2 + -1 / 4 * z = 0, z)),
(([2,1], Pbl), solve (-1 / 8 + z ^ 2 + -1 / 4 * z = 0, z)),
(([2,1,1], Pbl), solve (-1 / 8 + z ^ 2 + -1 / 4 * z = 0, z)),
(([2,1,1,1], Frm), -1 / 8 + z ^ 2 + -1 / 4 * z = 0)] 
*)
*}
ML {*
val denominator = parseNEW ctxt "-1/8 + -1/4*z + z^2 = 0";
(*ergebnis: [gleichung, was tun?, lösung]*)
val fmz = ["equality (-1/8 + -1/4*z + z^2 = (0::real))", "solveFor z","solutions L"];
(*liste der theoreme die zum lösen benötigt werden, aus isac, keine spezielle methode (no met)*)
val (dI',pI',mI') =
  ("Isac", ["pqFormula","degree_2","polynomial","univariate","equation"], ["no_met"]);
(*schritte abarbeiten*)
val (p,_,f,nxt,_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt; (*val nxt = ("Empty_Tac", ...): tac'_*)
show_pt pt;
*}

subsection {*partial fraction decomposition*}
subsubsection {*solution of the equation*}
ML {*
val SOME solutions = parseNEW ctxt "[z=1/2, z=-1/4]";
term2str solutions;
atomty solutions;
*}

subsubsection {*get solutions out of list*}
text {*in isac's CTP-based programming language: let s_1 = NTH 1 solutions; s_2 = NTH 2...*}
ML {*
val Const ("List.list.Cons", _) $ s_1 $ (Const ("List.list.Cons", _) $
      s_2 $ Const ("List.list.Nil", _)) = solutions;
term2str s_1;
term2str s_2;
*}

ML {* (*Solutions as Denominator --> Denominator1 = z - Zeropoint1, Denominator2 = z-Zeropoint2,...*)
val xx = HOLogic.dest_eq s_1;
val s_1' = HOLogic.mk_binop "Groups.minus_class.minus" xx;
val xx = HOLogic.dest_eq s_2;
val s_2' = HOLogic.mk_binop "Groups.minus_class.minus" xx;
term2str s_1';
term2str s_2';
*}

subsubsection {*build expression*}
text {*in isac's CTP-based programming language: let s_1 = Take numerator / (s_1 * s_2)*}
ML {*
(*The Main Denominator is the multiplikation of the partial fraction denominators*)
val denominator' = HOLogic.mk_binop "Groups.times_class.times" (s_1', s_2') ;
val SOME numerator = parseNEW ctxt "3::real";

val expression' = HOLogic.mk_binop "Rings.inverse_class.divide" (numerator, denominator');
term2str expression';
*}

subsubsection {*Ansatz - create partial fractions out of our expression*}

axiomatization where
  ansatz2: "n / (a*b) = A/a + B/(b::real)" and
  multiply_eq2: "(n / (a*b) = A/a + B/b) = (a*b*(n  / (a*b)) = a*b*(A/a + B/b))"

ML {*
(*we use our ansatz2 to rewrite our expression and get an equilation with our expression on the left and the partial fractions of it on the right side*)
val SOME (t1,_) = rewrite_ @{theory Isac} e_rew_ord e_rls false @{thm ansatz2} expression';
term2str t1;
atomty t1;
val eq1 = HOLogic.mk_eq (expression', t1);
term2str eq1;
*}
ML {*
(*eliminate the demoninators by multiplying the left and the right side with the main denominator*)
val SOME (eq2,_) = rewrite_ @{theory Isac} e_rew_ord e_rls false @{thm multiply_eq2} eq1;
term2str eq2;
*}
ML {*
(*simplificatoin*)
val SOME (eq3,_) = rewrite_set_ @{theory Isac} false norm_Rational eq2;
term2str eq3; (*?A ?B not simplified*)
*}
ML {*
val SOME fract1 =
  parseNEW ctxt "(z - 1 / 2) * (z - -1 / 4) * (A / (z - 1 / 2) + B / (z - -1 / 4))"; (*A B !*)
val SOME (fract2,_) = rewrite_set_ @{theory Isac} false norm_Rational fract1;
term2str fract2 = "(A + -2 * B + 4 * A * z + 4 * B * z) / 4";
(*term2str fract2 = "A * (1 / 4 + z) + B * (-1 / 2 + z)" would be more traditional*)
*}
ML {*
val (numerator, denominator) = HOLogic.dest_eq eq3;
val eq3' = HOLogic.mk_eq (numerator, fract1); (*A B !*)
term2str eq3';
*}
ML {* (*MANDATORY: otherwise 3 = 0*)
val SOME (eq3'' ,_) = rewrite_set_ @{theory Isac} false norm_Rational eq3';
term2str eq3'';
*}

subsubsection {*get first koeffizient*}

ML {*
(*substitude z with the first zeropoint to get A*)
val SOME (eq4_1,_) = rewrite_terms_ @{theory Isac} e_rew_ord e_rls [s_1] eq3'';
term2str eq4_1;
*}
ML {*
val SOME (eq4_2,_) = rewrite_set_ @{theory Isac} false norm_Rational eq4_1;
term2str eq4_2;
*}
ML {*
val fmz = ["equality (3 = 3 * A / (4::real))", "solveFor A","solutions L"];
val (dI',pI',mI') =("Isac", ["univariate","equation"], ["no_met"]);

*}
ML {*
(*solve the simple linear equilation for A*)
val (p,_,f,nxt,_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
val (p,_,f,nxt,_,pt) = me nxt p [] pt;
*}
ML {*
val (p,_,f,nxt,_,pt) = me nxt p [] pt; 
f2str f;
*}

subsubsection {*get second koeffizient*}

ML {*
(*substitude z with the second zeropoint to get B*)
val SOME (eq4b_1,_) = rewrite_terms_ @{theory Isac} e_rew_ord e_rls [s_2] eq3'';
term2str eq4_1;
*}

ML {*
val SOME (eq4b_2,_) = rewrite_set_ @{theory Isac} false norm_Rational eq4b_1;
term2str eq4b_2;
*}

ML {*
(*solve the simple linear equilation for B*)

val fmz = ["equality (3 = -3 * B / (4::real))", "solveFor B","solutions L"];
val (dI',pI',mI') =("Isac", ["univariate","equation"], ["no_met"]);

val (p,_,fb,nxt,_,pt) = CalcTreeTEST [(fmz, (dI',pI',mI'))];
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt;
val (p,_,fb,nxt,_,pt) = me nxt p [] pt; 
f2str fb;
*}

ML {* (*check koeffizients*)
if f2str f = "[A = 4]" then () else error "part.fract. eq4_1";
if f2str fb = "[B = -4]" then () else error "part.fract. eq4_1";
*}

end

